package net.ihe.gazelle.hpd.simulator.providerinfodirectory;

import net.ihe.gazelle.hpd.BatchRequest;
import net.ihe.gazelle.hpd.BatchResponse;
import net.ihe.gazelle.hpd.ErrorResponse;
import net.ihe.gazelle.hpdTransformer.HPDTransformer;
import org.apache.directory.api.asn1.ber.Asn1Decoder;
import org.apache.directory.api.dsmlv2.DsmlControl;
import org.apache.directory.api.dsmlv2.DsmlDecorator;
import org.apache.directory.api.dsmlv2.Dsmlv2Parser;
import org.apache.directory.api.dsmlv2.engine.Dsmlv2Engine;
import org.apache.directory.api.dsmlv2.request.BatchRequestDsml;
import org.apache.directory.api.dsmlv2.request.SearchRequestDsml;
import org.apache.directory.api.dsmlv2.response.BatchResponseDsml;
import org.apache.directory.api.dsmlv2.response.SearchResponseDsml;
import org.apache.directory.api.dsmlv2.response.SearchResultDoneDsml;
import org.apache.directory.api.dsmlv2.response.SearchResultEntryDsml;
import org.apache.directory.api.ldap.codec.controls.search.pagedSearch.PagedResultsContainer;
import org.apache.directory.api.ldap.codec.controls.search.pagedSearch.PagedResultsDecorator;
import org.apache.directory.api.ldap.codec.controls.sort.SortRequestContainer;
import org.apache.directory.api.ldap.codec.controls.sort.SortRequestDecorator;
import org.apache.directory.api.ldap.codec.osgi.DefaultLdapCodecService;
import org.apache.directory.api.ldap.codec.standalone.StandaloneLdapApiService;
import org.apache.directory.api.ldap.model.entry.Entry;
import org.apache.directory.api.ldap.model.message.Control;
import org.apache.directory.ldap.client.api.LdapConnection;
import org.apache.directory.ldap.client.api.LdapNetworkConnection;
import org.apache.directory.ldap.client.api.SearchCursorImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xmlpull.v1.XmlPullParserException;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;
import java.nio.charset.StandardCharsets;
import java.util.Map;

public class DSMLConnector {

    public static final String END_TAG = "?>";
    private static Logger LOGGER = LoggerFactory.getLogger(DSMLConnector.class);
    private static final int DEFAULT_TIMEOUT = 10000;

    private String ldapServerIp;
    private Integer ldapServerPort;
    private int connectionTimeout;
    private String ldapUser;
    private String ldapUserPassword;
    private LdapConnection connection;

    /**
     * @param inServerIp   : the server we want to connect to
     * @param inServerPort : the port the server is listenning to
     * @param ldapUsername : the user name to be used to bind this connection to the server
     * @param ldapPassword : user's credentials
     */
    public DSMLConnector(String inServerIp, Integer inServerPort, String ldapUsername, String ldapPassword) {
        this.ldapServerIp = inServerIp;
        this.ldapServerPort = inServerPort;
        this.connectionTimeout = 0;
        if (ldapUsername != null && !ldapUsername.isEmpty()) {
            this.ldapUser = ldapUsername;
        } else {
            this.ldapUser = null;
        }
        if (ldapPassword != null && !ldapPassword.isEmpty()) {
            this.ldapUserPassword = ldapPassword;
        } else {
            this.ldapUserPassword = null;
        }
    }

    public BatchResponse processRequest(BatchRequest inRequest) throws Exception {
        // prepare response and request
        ByteArrayOutputStream response = new ByteArrayOutputStream();
        ByteArrayOutputStream requestContent = new ByteArrayOutputStream();
        HPDTransformer.marshallMessage(BatchRequest.class, requestContent, inRequest);
        ByteArrayInputStream request = new ByteArrayInputStream(requestContent.toByteArray());
        // forward request to LDAP server
        openConnection();
        Dsmlv2Engine engine = new Dsmlv2Engine(connection, ldapUser, ldapUserPassword);
        engine.processDSML(request, response);
        String responseString = new String(response.toByteArray());
        responseString = formatDsml(responseString);
        if (isDsml(responseString)) {
            ByteArrayInputStream responseContent = new ByteArrayInputStream(responseString.getBytes());
            return HPDTransformer.unmarshallMessage(BatchResponse.class, responseContent);
        }
        // there is an error in the response generated by Dsmlv2Engine --> wrong namespace
        else {
            return batchResponseFromErrorMessage(responseString, inRequest.getRequestID());
        }
    }

    public BatchResponse processRequestManual(BatchRequest inRequest) throws Exception {
        // prepare response and request
        ByteArrayOutputStream requestContent = new ByteArrayOutputStream();
        HPDTransformer.marshallMessage(BatchRequest.class, requestContent, inRequest);
        requestContent = fixXsdNamespace(requestContent);
        ByteArrayOutputStream response = new ByteArrayOutputStream();
        //ByteArrayInputStream request = new ByteArrayInputStream(inRequest.getBytes(StandardCharsets.UTF_8));
        ByteArrayInputStream request = new ByteArrayInputStream(requestContent.toByteArray());
        BatchRequestDsml requestv2Parsed = parseDSML(request);

        SearchRequestDsml searchRequestDsml;
        BatchResponseDsml batchResponseDsml = new BatchResponseDsml();
        for (DsmlDecorator dsmlDecorator : requestv2Parsed.getRequests()) {
            if (dsmlDecorator instanceof SearchRequestDsml) {
                searchRequestDsml = (SearchRequestDsml) requestv2Parsed.getCurrentRequest();
            } else {
                return null;
            }

            //fix control
            for (Map.Entry<String, Control> entry : searchRequestDsml.getControls().entrySet()) {
                searchRequestDsml.removeControl(entry.getValue());
                DsmlControl dsmlControl = (DsmlControl) entry.getValue();
                if (dsmlControl.getDecorated() instanceof PagedResultsDecorator) {
                    PagedResultsDecorator pagedResults = (PagedResultsDecorator) dsmlControl.getDecorated();
                    DefaultLdapCodecService defaultLdapCodecService = new DefaultLdapCodecService();
                    PagedResultsContainer container = new PagedResultsContainer(defaultLdapCodecService, pagedResults);
                    Asn1Decoder asn1Decoder = new Asn1Decoder();
                    asn1Decoder.decode(ByteBuffer.wrap(dsmlControl.getValue()), container);
                    searchRequestDsml.addControl(container.getDecorator().getDecorated());
                }
                if (dsmlControl.getDecorated() instanceof SortRequestDecorator) {
                    SortRequestDecorator sortResults = (SortRequestDecorator) dsmlControl.getDecorated();
                    DefaultLdapCodecService defaultLdapCodecService = new DefaultLdapCodecService();
                    SortRequestContainer container = new SortRequestContainer(defaultLdapCodecService, sortResults);
                    Asn1Decoder asn1Decoder = new Asn1Decoder();
                    asn1Decoder.decode(ByteBuffer.wrap(dsmlControl.getValue()), container);
                    searchRequestDsml.addControl(container.getControl());
                }
            }
            try (LdapConnection connection = new LdapNetworkConnection(ldapServerIp, ldapServerPort)) {
                connection.bind(ldapUser, ldapUserPassword);
                SearchCursorImpl searchCursor = (SearchCursorImpl) connection.search(searchRequestDsml.getDecorated());

                StandaloneLdapApiService service = new StandaloneLdapApiService();
                SearchResponseDsml searchResponseDsml = new SearchResponseDsml(service);
                while (searchCursor.next()) {
                    Entry result = searchCursor.getEntry();
                    SearchResultEntryDsml searchResultEntryDsml = new SearchResultEntryDsml(service);
                    searchResultEntryDsml.setEntry(result);
                    searchResponseDsml.addResponse(searchResultEntryDsml);
                }
                SearchResultDoneDsml searchResultDoneDsml = new SearchResultDoneDsml(service, searchCursor.getSearchResultDone());
                searchResponseDsml.addResponse(searchResultDoneDsml);
                batchResponseDsml.addResponse(searchResponseDsml);
            }
        }

        //System.setProperty("javax.xml.transform.TransformerFactory", "com.sun.org.apache.xalan.internal.xsltc.trax.TransformerFactoryImpl");
        ByteArrayInputStream dsmlResponse = new ByteArrayInputStream(batchResponseDsml.toDsml(false).getBytes(StandardCharsets.UTF_8));
        return HPDTransformer.unmarshallMessage(BatchResponse.class, dsmlResponse);
    }

    public ByteArrayOutputStream fixXsdNamespace(ByteArrayOutputStream outputStream) {
        String request = outputStream.toString();
        if (request.contains("base64Binary")) {
            String fixedRequest = request.replaceAll("(\\w)*:base64Binary", "xs:base64Binary");
            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            try {
                byteArrayOutputStream.write(fixedRequest.getBytes(StandardCharsets.UTF_8));
                return byteArrayOutputStream;
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return outputStream;
    }

    private BatchRequestDsml parseDSML(InputStream inputStream) {
        Dsmlv2Parser parser = null;
        try {
            parser = new Dsmlv2Parser();
        } catch (XmlPullParserException e) {
            return null;
        }
        try {
            //parser.setInput(inputStream, "UTF-8");
            parser.setInput(inputStream, null);
        } catch (XmlPullParserException e) {
            return null;
        }
        try {
            parser.parse();
        } catch (XmlPullParserException e) {
            return null;
        } catch (IOException e) {
            return null;
        }
        return parser.getBatchRequest();
    }

    /**
     * bug in Dsmlv2Engine, response is malformed when it contains an errorMessage
     * manually fix it until it is fixed in the third-part library
     * see HPD-128
     *
     * @param responseString
     */
    private String formatDsml(String responseString) {
        if (responseString != null && responseString.contains("<?xml")) {
            // find index of ?> and remove the beginning of the message
            int start = responseString.indexOf(END_TAG);
            if (start > 0) {
                return responseString.substring(start + END_TAG.length());
            }
        }
        return responseString;
    }

    private BatchResponse batchResponseFromErrorMessage(String responseString, String requestID) {
        BatchResponse response = new BatchResponse();
        ErrorResponse errorResponse = new ErrorResponse();
        errorResponse.setMessage(responseString);
        errorResponse.setRequestID(requestID);
        response.addErrorResponse(errorResponse);
        return response;
    }

    private boolean isDsml(String responseContent) {
        return responseContent != null && responseContent.startsWith("<batchResponse");
    }

    private void openConnection() throws IOException {
        closeConnection();
        if ((ldapServerIp != null) && (ldapServerPort != null)) {
            connection = new LdapNetworkConnection(ldapServerIp, ldapServerPort);
            connection.setTimeOut(DEFAULT_TIMEOUT);
        } else {
            LOGGER.warn("The connection is already opened");
        }
    }

    private void closeConnection() throws IOException {
        if ((connection != null) && connection.isConnected()) {
            connection.close();
            connection = null;
        } else {
            LOGGER.info("Connection was closed, nothing to do !");
        }
    }

    public String getLdapServerIp() {
        return ldapServerIp;
    }

    public void setLdapServerIp(String ldapServerIp) {
        this.ldapServerIp = ldapServerIp;
    }

    public Integer getLdapServerPort() {
        return ldapServerPort;
    }

    public void setLdapServerPort(Integer ldapServerPort) {
        this.ldapServerPort = ldapServerPort;
    }

    public int getConnectionTimeout() {
        return connectionTimeout;
    }

    public void setConnectionTimeout(int connectionTimeout) {
        this.connectionTimeout = connectionTimeout;
    }

}
